/* or_tables.c: various tables of values */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_tables.c,v 5.0 90/09/20 16:08:49 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_tables.c,v 5.0 90/09/20 16:08:49 pp Exp Locker: pp $
 *
 * $Log:	or_tables.c,v $
 * Revision 5.0  90/09/20  16:08:49  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "or.h"
#include <isode/cmd_srch.h>

typestruct typetab[] = {
    "C",        OR_C,           OR_ENC_PS,
    "ADMD",     OR_ADMD,        OR_ENC_PS,
    "PRMD",     OR_PRMD,        OR_ENC_PS,
    "X121",     OR_X121,        OR_ENC_NUM,
    "T-ID",     OR_TID,         OR_ENC_NUM,
    "O",        OR_O,           OR_ENC_PS,
    "OU",       OR_OU,          OR_ENC_PS,
    "UA-ID",    OR_UAID,        OR_ENC_NUM,
    "S",        OR_S,           OR_ENC_PS,
    "G",        OR_G,           OR_ENC_PS,
    "I",        OR_I,           OR_ENC_PS,
    "GQ",       OR_GQ,          OR_ENC_PS,
    0,          0,              0
    };



char    _pstable[] = {
    0, 0, 0, 0,                         /* 000-003      nul             */
    0, 0, 0, 0,                         /* 004-007                      */
    0, 0, 0, 0,                         /* 010-013      bs tab lf       */
    0, 0, 0, 0,                         /* 014-017                      */
    0, 0, 0, 0,                         /* 020-023                      */
    0, 0, 0, 0,                         /* 024-027                      */
    0, 0, 0, 0,                         /* 030-033                      */
    0, 0, 0, 0,                         /* 034-037                      */
    CHR_PS|CHR_NS, 0, 0, 0,             /* 040-043      sp !  "  #      */
    0, 0, 0, CHR_PS,                    /* 044-047      $  %  &  '      */
    CHR_PS, CHR_PS, 0, CHR_PS,          /* 050-053      ( )  *  +       */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 054-057      ,  -  .  /      */
    CHR_PS|CHR_NS, CHR_PS|CHR_NS, CHR_PS|CHR_NS, CHR_PS|CHR_NS,
					/* 060-063      0 1  2  3       */
    CHR_PS|CHR_NS, CHR_PS|CHR_NS, CHR_PS|CHR_NS, CHR_PS|CHR_NS,     
					/* 014-067      4  5  6  7      */
    CHR_PS|CHR_NS, CHR_PS|CHR_NS, CHR_PS, 0,
					/* 070-073      8  9  :  ;      */
    0, CHR_PS, 0, CHR_PS,               /* 074-077      <  =  >  ?      */
    0, CHR_PS, CHR_PS, CHR_PS,          /* 100-103      @  A  B  C      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 014-107      D  E  F  G      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 110-114      H  I  J  K      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 115-117      L  M  N  O      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 120-123      P  Q  R  S      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 124-127      T  U  V  W      */
    CHR_PS, CHR_PS, CHR_PS, 0,          /* 130-133      X  Y  Z [      */
    0, 0, 0, 0,                         /* 134-137      \  ]  ^  _      */
    0, CHR_PS, CHR_PS, CHR_PS,          /* 140-143      `  a  b  c      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 144-147      d  e  f  g      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 150-153      h  i  j  k      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 154-157      l  m  n  o      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 160-163      p  q  r  s      */
    CHR_PS, CHR_PS, CHR_PS, CHR_PS,     /* 164-167      t  u  v  w      */
    CHR_PS, CHR_PS, CHR_PS, 0,          /* 170-173      x  y  z  {      */
    0, 0, 0, 0,                         /* 174-177      |  }  ~  del    */
    };





CMD_TABLE ortbl_ddvalid[] = { /* ddvalid keys */
	"RFC-822",      OR_DDVALID_RFC822,
	"JNTMAIL",      OR_DDVALID_JNT,
	"UUCP",         OR_DDVALID_UUCP,
	"LIST",         OR_DDVALID_LIST,
	"ROLE",         OR_DDVALID_ROLE,
	"FAX",		OR_DDVALID_FAX,
	"ATTN",		OR_DDVALID_ATTN,
	0,              -1
	};
