/* rfc822_add.c: adds the rfc822 part of the address */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/parse/RCS/rfc822_add.c,v 5.0 90/09/20 16:09:32 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/parse/RCS/rfc822_add.c,v 5.0 90/09/20 16:09:32 pp Exp Locker: pp $
 *
 * $Log:	rfc822_add.c,v $
 * Revision 5.0  90/09/20  16:09:32  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "head.h"
#include "or.h"
#include "adr.h"


/* ---------------------  Begin  Routines  -------------------------------- */


void rfc822_add (ad)
ADDR    *ad;
{
	int             retval;
	char            tbuf[LINESIZE];
	OR_ptr          or;

	PP_DBG (("rfc822_add (%s)", ad->ad_value));

	or = or_std2or (ad -> ad_r400adr ? ad -> ad_r400adr :
			ad -> ad_value);
	retval = or_or2rfc (or, tbuf);

	if (retval == NOTOK){
		PP_TRACE (("rfc822_add (or_or2rfc failed!)"));
		ad->ad_parse_stat = RP_PARSE;
		return;
	}
/* Need to do normalisation!!!! */

	if (ad->ad_r822adr)
		free (ad->ad_r822adr);

	ad->ad_r822adr = strdup (tbuf);

	PP_DBG (("rfc822_add returns (tbuf=%s)", tbuf));
}
